{
 "metadata": {
  "name": ""
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": [
      "9: Abstract Data Types"
     ]
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 1: Page 167"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates a stack implemented as a list\n",
      "\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd\t#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\t\t\n",
      "\tdef displayLink(self):\t#display ourself\n",
      "\t\tprint self.dData,\n",
      "#end class Link\n",
      "\n",
      "class LinkList:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#first item on list\n",
      "\t\t#(no links on list yet)\n",
      "\n",
      "\tdef __del__(self):\t#destructor (deletes list)\n",
      "\t\tself.__init__()\n",
      "\n",
      "\tdef isEmpty(self):\t#true if list is empty\n",
      "\t\treturn self._pFirst == None\n",
      "\n",
      "\tdef insertFirst(self, dd):\t#insert at start of list\n",
      "\t\t#make new link\n",
      "\t\tpNewLink = Link(dd)\n",
      "\t\tpNewLink.pNext = self._pFirst\t#newLink-->old first\n",
      "\t\tself._pFirst = pNewLink\t#first-->newLink\n",
      "\n",
      "\tdef deleteFirst(self):\t#delete first item\n",
      "\t\t#(assumes list not empty)\n",
      "\t\tpTemp = self._pFirst\t#save old first link\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#remove it: first-->old next\n",
      "\t\tkey = pTemp.dData\t#remember data\n",
      "\t\tdel pTemp\t#delete old first link\n",
      "\t\treturn key\t#return deleted link's data\n",
      "\n",
      "\tdef displayList(self):\t#display all links\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning of list\n",
      "\t\twhile pCurrent:\t#until end of list,\n",
      "\t\t\tpCurrent.displayLink()\t#print data\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "#end class LinkList\n",
      "\n",
      "class LinkStack:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pList = LinkList()\t#make a linked list\n",
      "\n",
      "\tdef __del__(self):\t#destructor\n",
      "\t\tdel self._pList\t#delete the linked list\n",
      "\n",
      "\tdef push(self, j):\t#put item on top of stack\n",
      "\t\tself._pList.insertFirst(j)\n",
      "\n",
      "\tdef pop(self):\t#take item from top of stack\n",
      "\t\tself._pList.deleteFirst()\n",
      "\n",
      "\tdef isEmpty(self):\t#true if stack is empty\n",
      "\t\treturn self._pList.isEmpty()\n",
      "\n",
      "\tdef displayStack(self):\n",
      "\t\tprint\n",
      "\t\tprint 'Stack (top-->bottom):',\n",
      "\t\tself._pList.displayList()\n",
      "#end class LinkStack\n",
      "\n",
      "theStack = LinkStack()\t#make stack\n",
      "\n",
      "theStack.push(20)\t#push items\n",
      "theStack.push(40)\n",
      "\n",
      "theStack.displayStack()\t#display stack (40, 20)\n",
      "\n",
      "theStack.push(60)\t#push items\n",
      "theStack.push(80)\n",
      "\n",
      "theStack.displayStack()\t#display (80, 60, 40, 20,)\n",
      "\n",
      "theStack.pop()\t#pop items (80, 60)\n",
      "theStack.pop()\n",
      "\n",
      "theStack.displayStack()\t#display stack (40, 20)\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "\n",
        "Stack (top-->bottom): 40 20\n",
        "Stack (top-->bottom): 80 60 40 20\n",
        "Stack (top-->bottom): 40 20\n"
       ]
      }
     ],
     "prompt_number": 1
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 2: Page 171"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates list with first and last references\n",
      "\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd\t#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\t\t\n",
      "\tdef displayLink(self):\t#display this link\n",
      "\t\tprint self.dData,\n",
      "#end class Link\n",
      "\n",
      "class FirstLastList:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#first link\n",
      "\t\tself._pLast = None\t#last link\n",
      "\n",
      "\tdef __del__(self):\t#destructor\n",
      "\t\tself.__init__()\t#deletes list\n",
      "\n",
      "\tdef isEmpty(self):\t#true if no links\n",
      "\t\treturn self._pFirst == None\n",
      "\n",
      "\tdef insertFirst(self, dd):\t#insert at front of list\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\t\tif self.isEmpty():\t#if empty list,\n",
      "\t\t\tself._pLast = pNewLink\t#newLink <-- last\n",
      "\t\tpNewLink.pNext = self._pFirst\t#newLink-->old first\n",
      "\t\tself._pFirst = pNewLink\t#first-->newLink\n",
      "\n",
      "\tdef insertLast(self, dd):\t#insert at end of list\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\t\tif self.isEmpty():\t#if empty list,\n",
      "\t\t\tself._pFirst = pNewLink\t#first --> newLink\n",
      "\t\telse:\n",
      "\t\t\tself._pLast.pNext = pNewLink\t#old last --> newLink\n",
      "\t\tself._pLast = pNewLink\t#newLink <--last\n",
      "\n",
      "\tdef removeFirst(self):\t#remove first link\n",
      "\t\t#(assumes non-empty list)\n",
      "\t\tpTemp = self._pFirst\t#remember first link\n",
      "\t\tif not self._pFirst.pNext:\t#if only one item\n",
      "\t\t\tself._pLast = None#None <-- last\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#first-->old next\n",
      "\t\tdel pTemp\t#delete the link\n",
      "\t\t\n",
      "\tdef displayList(self):\n",
      "\t\tprint 'List (first-->last):',\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning\n",
      "\t\twhile pCurrent:\t#until end of list,\n",
      "\t\t\tpCurrent.displayLink()\t#print data\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "#end class FirstLastList\n",
      "\n",
      "theList = FirstLastList()\t#make new list\n",
      "\n",
      "theList.insertFirst(22)\t#insert at front\n",
      "theList.insertFirst(44)\n",
      "theList.insertFirst(66)\n",
      "\n",
      "theList.insertLast(11)\t#insert at rear\n",
      "theList.insertLast(33)\n",
      "theList.insertLast(55)\n",
      "\n",
      "theList.displayList()\t#display the list\n",
      "\n",
      "print\n",
      "print 'Deleting first two items'\n",
      "\n",
      "theList.removeFirst()\t#remove first two items\n",
      "theList.removeFirst()\n",
      "\n",
      "theList.displayList()\t#display again\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "List (first-->last): 66 44 22 11 33 55\n",
        "Deleting first two items\n",
        "List (first-->last): 22 11 33 55\n"
       ]
      }
     ],
     "prompt_number": 2
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 3: Page 175"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates queue implemented as double-ended list\n",
      "\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd\t#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\t\t\n",
      "\tdef displayLink(self):\t#display this link\n",
      "\t\tprint self.dData,\n",
      "#end class Link\n",
      "\n",
      "class FirstLastList:\n",
      "\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#first link\n",
      "\t\tself._pLast = None\t#last link\n",
      "\n",
      "\tdef __del__(self):\t#destructor\n",
      "\t\tself.__init__()\t#deletes list\n",
      "\n",
      "\tdef isEmpty(self):\t#true if no links\n",
      "\t\treturn self._pFirst == None\n",
      "\n",
      "\tdef insertLast(self, dd):\t#insert at end of list\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\t\tif self.isEmpty():\t#if empty list,\n",
      "\t\t\tself._pFirst = pNewLink\t#first --> newLink\n",
      "\t\telse:\n",
      "\t\t\tself._pLast.pNext = pNewLink\t#old last --> newLink\n",
      "\t\tself._pLast = pNewLink\t#newLink <--last\n",
      "\n",
      "\tdef removeFirst(self):\t#delete first link\n",
      "\t\t#(assumes non-empty list)\n",
      "\t\tpTemp = self._pFirst\t#remember first link\n",
      "\t\ttemp = self._pFirst.dData\n",
      "\t\tif not self._pFirst.pNext:\t#if only one item\n",
      "\t\t\tself._pLast = None#None <-- last\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#first-->old next\n",
      "\t\tdel pTemp\t#delete the link\n",
      "\t\treturn temp\n",
      "\t\t\n",
      "\tdef displayList(self):\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning\n",
      "\t\twhile pCurrent:\t#until end of list,\n",
      "\t\t\tpCurrent.displayLink()\t#print data\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "#end class FirstLastList\n",
      "\n",
      "class LinkQueue:\n",
      "\tdef __init__(self):\n",
      "\t\tself._theList = FirstLastList()\n",
      "\n",
      "\tdef isEmpty(self):\t#true if queue is empty\n",
      "\t\treturn self._theList.isEmpty()\n",
      "\n",
      "\tdef insert(self, j):\t#insert, rear of queue\n",
      "\t\tself._theList.insertLast(j)\n",
      "\n",
      "\tdef remove(self):\t#remove, front of queue\n",
      "\t\treturn self._theList.removeFirst()\n",
      "\n",
      "\tdef displayQueue(self):\n",
      "\t\tprint 'Queue (front-->rear):',\n",
      "\t\tself._theList.displayList()\n",
      "\t\tprint\n",
      "#end class LinkQueue\n",
      "\n",
      "theQueue = LinkQueue()\t#make a queue\n",
      "\n",
      "theQueue.insert(20)\t#insert items\n",
      "theQueue.insert(40)\n",
      "\n",
      "theQueue.displayQueue()\t#display queue (20, 40)\n",
      "\n",
      "theQueue.insert(60)\t#insert items\n",
      "theQueue.insert(80)\n",
      "\n",
      "theQueue.displayQueue()\t#display queue (20, 40, 60, 80)\n",
      "\n",
      "print 'Removing two items'\n",
      "theQueue.remove()\t#remove items (20, 40)\n",
      "theQueue.remove()\n",
      "\n",
      "theQueue.displayQueue()\t#display queue (60, 80)"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "Queue (front-->rear): 20 40\n",
        "Queue (front-->rear): 20 40 60 80\n",
        "Removing two items\n",
        "Queue (front-->rear): 60 80\n"
       ]
      }
     ],
     "prompt_number": 3
    }
   ],
   "metadata": {}
  }
 ]
}